# -*- coding: UTF-8 -*-

require_relative  'send_util'
require_relative  '../config'
require_relative  '../vo/response'
require "json"
#发送邮件module
module SendMailModule
  #发送普通邮件
  def send_mail(mail)
    #验证参数(简单的参数验证,详情参考api文档,或根据业务需求自行校验)
    if mail.nil?
      return  Response.new(false,"","mail can not be nil","")
    end
    if mail.apiUser.empty?
      return Response.new(false,"","apiUser can not be empty","")
    end
    if mail.apiKey.empty?
      return Response.new(false,"","apiKey can not be empty","")
    end
    if mail.subject.empty?
      return  Response.new(false,"","subject can not be empty","")
    end
    if mail.from.empty?
      return  Response.new(false,"","to can not be empty","")
    end


    #开始发送
    #填充发送参数
    param_hash = {}
    begin
      mail.instance_variables.each { |item|
        param_hash[item.slice(1,item.size)] =  mail.instance_variable_get(item)
      }

      #发送
      res=JSON.parse(SendUtil.send_post(Config::SEND_MAIL,param_hash))
      # puts res
    rescue
      puts "error:#{$!} at:#{$@}"
      return Response.new(false,"","send mail fail","")
    end

    #发送结果
    return Response.new(res["result"],res["statusCode"],res["message"],res["info"])
  end

  #发送模板邮件
  def send_tempalte(mail)
    #验证参数
    if mail.nil?
      return  Response.new(false,"","mail can not be nil","")
    end
    if mail.apiUser.empty?
      return Response.new(false,"","apiUser can not be empty","")
    end
    if mail.apiKey.empty?
      return Response.new(false,"","apiKey can not be empty","")
    end
    if mail.templateInvokeName.empty?
      return  Response.new(false,"","templateInvokeName can not be empty","")
    end
    if mail.from.empty?
      return  Response.new(false,"","to can not be empty","")
    end
    #使用地址列表发送,to不能为空,否则xsmtpapi不能为空
    # if mail.useAddressList
    #   if mail.to.empty?
    #     return Response.new(false,"","when useAddressList,to can not be empty","")
    #   end
    # else if mail.xsmtpapi.empty?
    #   return Response.new(false,"","when unUseAddressList,xsmtpapi can not be empty","")
    # end

    #开始发送
    #填充发送参数
    param_hash = {}
    begin
      mail.instance_variables.each { |item|
        param_hash[item.slice(1,item.size)] =  mail.instance_variable_get(item)
      }

      #发送
      res=JSON.parse(SendUtil.send_post(Config::SEND_TEMPLATE,param_hash))
     # puts res
    rescue
      puts "error:#{$!} at:#{$@}"
      return Response.new(false,"","send mail fail","")
    end

    #发送结果
    return Response.new(res["result"],res["statusCode"],res["message"],res["info"])
  end
end
