#!/usr/bin/env ruby
# -*- coding: UTF-8 -*-

require_relative "vo/mail"
require_relative "module/send_mail_module"
require_relative "config"


BEGIN {
  puts "send mail begin"
}

#发送邮件
class SendMail
  include SendMailModule

  #测试邮件普通发送
  def test_send_mail
    mail= Mail.new()
    mail.apiUser=Config::API_USER
    mail.apiKey=Config::API_KEY
    mail.from="test@test.com"
    #不使用地址列表发送,to表示发送对象
    mail.to="***@qq.com"
    mail.subject="测试"
    mail.plain="这是一封测试邮件"
    mail.fromName="来自邮件测试发送"
    #...(可选参数,详情见邮件api)

    res=send_mail(mail)
    if res.result
      puts "send mail succss,info:#{res.info}"
    else
      puts "send mail fail:#{res.message}"
    end
  end

  #测试邮件模板发送
  def test_send_mail_template
    mail= Mail.new()
    mail.apiUser=Config::API_USER
    mail.apiKey=Config::API_KEY
    mail.from="test@test.com"
    mail.xsmtpapi='{"to":["***@qq.com"],"sub":{}}'
    mail.subject="邮件模板测试"
    mail.templateInvokeName="admin_send"
    mail.fromName="来自邮件模板测试发送"
    #....

    res=send_tempalte(mail)
    if res.result
      puts "send tempalte mail succss,info:#{res.info}"
    else
      puts "send tempalte mail fail:#{res.message}"
    end
  end

  #测试邮件普通发送(带地址列表)
  def test_send_mail_with_address_list
    mail= Mail.new()
    mail.apiUser=Config::API_USER
    mail.apiKey=Config::API_KEY
    mail.from="test@test.com"
    mail.subject="地址列表测试"
    mail.plain="这是一封测试邮件(地址列表)"
    mail.fromName="来自邮件测试发送(地址列表)"

    #使用地址列表,to表示地址列表别称
    mail.to="****@sendcloud.io"
    mail.useAddressList=true
    #....

    res=send_mail(mail)
    if res.result
      puts "send mail  useAddressList succss,info:#{res.info}"
    else
      puts "send mail useAddressList fail:#{res.message}"
    end
  end
end

begin

  send=SendMail.new
  #测试邮件发送
  send.test_send_mail
  #测试邮件模板发送
  send.test_send_mail_template
  #测试邮件普通发送(带地址列表)
  send.test_send_mail_with_address_list

rescue
  puts "error:#{$!} at:#{$@}"
  puts "send encounters error,Execution has terminated"
ensure
end

END {
  puts "send mail end"
}
